/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		XApplication.cpp
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			pHreak
//
// Erstelldatum:	23.08.2000
// letzte nderung:	11.03.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Die Klasse XApplication ermoeglicht die einfache Erstellung eines
//					Applikationsfensters
/////////////////////////////////////////////////////////////////////////////////////
// Copyright 2000/2001 by x-treme
/////////////////////////////////////////////////////////////////////////////////////

// XGame-includes
#include "XApplication.h"

// Methoden-Definitionen

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XApplication::initialize
/////////////////////////////////////////////////////////////////////////////////////
// Info:			erzeugt das Hauptfenster der Applikation
/////////////////////////////////////////////////////////////////////////////////////

HWND XApplication::initialize(HINSTANCE	hInstance,
							  LPCSTR	lpstrName,
							  LPCSTR	lpstrTitle,
							  WORD		wXAppIcon,
							  int		nCmdShow)
{
	if (m_hWnd)
	{
		#if defined(XDEBUG) || defined(XAPPLICATIONDEBUG)
		XLogging::log("XApplication::initialize > (WARNUNG!!!) Anwendungsfenster existiert bereits\n");
		#endif
			
		return m_hWnd;
	}

	WNDCLASS	wc;

	// Neue Fensterklasse anlegen...
	ZeroMemory(&wc,sizeof(wc));
	wc.style			= CS_VREDRAW|CS_HREDRAW;
	wc.lpfnWndProc		= ::wndProc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hInstance		= hInstance;
	wc.hIcon			= LoadIcon(hInstance,MAKEINTRESOURCE(wXAppIcon));
	wc.hCursor			= NULL;
	wc.hbrBackground	= NULL;
	wc.lpszMenuName		= NULL;
	wc.lpszClassName	= lpstrName;
	// ...und registrieren
	RegisterClass(&wc);

	// Vollbild-Fenster erzeugen
	m_hWnd = CreateWindow(lpstrName,
						lpstrTitle,
						WS_POPUP|WS_VISIBLE,
						CW_USEDEFAULT,CW_USEDEFAULT,
						CW_USEDEFAULT,CW_USEDEFAULT,
						GetDesktopWindow(),
						(HMENU) NULL,
						hInstance,
						(LPVOID) NULL);

	if (m_hWnd==NULL)
	{
		#if defined(XDEBUG) || defined(XAPPLICATIONDEBUG)
		XLogging::log("XApplication::initialize > (FEHLER!!!) Konnte Anwendungsfenster nicht erzeugen\n");
		#endif

		return NULL;
	}

	ShowWindow(m_hWnd,nCmdShow);	// Fenster anzeigen,
	UpdateWindow(m_hWnd);			// neu zeichnen...
	SetFocus(m_hWnd);				// ...und Fokus zuweisen.
	ShowCursor(false);				// Cursor fuer dieses Fenster ausschalten

	#if defined(XDEBUG) || defined(XAPPLICATIONDEBUG)
	XLogging::log("XApplication::initialize > Anwendungsfenster erzeugt\n");
	#endif

	return m_hWnd;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XApplication::getHWnd
/////////////////////////////////////////////////////////////////////////////////////
// Info:			gibt den Handle des Hauptfensters zurueck
/////////////////////////////////////////////////////////////////////////////////////

HWND XApplication::getHWnd(void)
{
	return m_hWnd;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XApplication::setWindowStyle
/////////////////////////////////////////////////////////////////////////////////////
// Info:			aendert den Style des Fensters
/////////////////////////////////////////////////////////////////////////////////////

LONG XApplication::setWindowStyle(LONG	lWindowStyle)
{
	if (!m_hWnd)
	{
		#if defined(XDEBUG) || defined(XAPPLICATIONDEBUG)
		XLogging::log("XApplication::setWindowStyle > (FEHLER!!!) Anwendungsfenster existiert noch nicht\n");
		#endif
			
		return 0;
	}
	
	return SetWindowLong(m_hWnd,GWL_STYLE,lWindowStyle);
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XApplication::XApplication
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Konstruktor. Initialisiert Datenmember
/////////////////////////////////////////////////////////////////////////////////////

XApplication::XApplication(void)
{
	m_hWnd = NULL;
}

/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	XApplication.cpp
/////////////////////////////////////////////////////////////////////////////////////