/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		XLogging.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Baal
//
// Erstelldatum:	12.09.2000
// letzte nderung:	17.08.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:			(statische) Klasse Xlogging, um in den Debugger-Output und/oder in eine Datei
//					zu loggen
/////////////////////////////////////////////////////////////////////////////////////
// Copyright 2000 by x-treme
/////////////////////////////////////////////////////////////////////////////////////


#define WIN32_LEAN_AND_MEAN		// Selten genutzte Teile aus Win-Header ausschliessen

#ifndef _XLOGGING_H
#define _XLOGGING_H


// Standard-Includes
#include <windows.h>
//#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fstream.h>

  

// XGame-includes


// Klasse XLogging
class	XLogging
{
	public:
		// setzt Context, des Loggings
		static void setContext(bool bDebug = true, 
								bool bFile = false, 
								bool bAppend = false, 
								char* pFileName = "XLogging.log");
		
		// ermittelt Context, des Loggings
		static void getContext(bool &bDebug, bool &bFile, bool &bAppend);
		
		// loggt Nachricht
		static void log(const char* pMessage, bool bTimeStamp = false);
		
		// wandelt integer und loggt diesen
		static void log(int nMessage, bool bTimeStamp = false);
		
		// wandelt long und loggt diesen
		static void log(long lMessage, bool bTimeStamp = false);

		// wandelt unsigned long und loggt diesen
		static void log(unsigned long ulMessage, bool bTimeStamp = false);

		// wandelt double und loggt diesen
		static void log(double dMessage, bool bTimeStamp = false);

	protected:
		static bool openFile(void);
		static bool closeFile(void);
		static bool clearFile(void);
		
		static bool getTime(char* pTime, int nTimeLength);

		static void logTime(void);
		static void logInFile(const char* pMessage);
		static void logInDebugger(const char* pMessage);
		
		static bool	m_bDebug,
					m_bFile,
					m_bAppend,
					m_bFileCreated;

		static char	m_cFileName[_MAX_PATH];

		static ofstream out;

	private:

};


#endif


class	XLogging;


/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	XLogging.h
/////////////////////////////////////////////////////////////////////////////////////