/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		XPlay.cpp
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Baal
//
// Version			1.1
// Erstelldatum:	18.09.2000
// letzte nderung:	04.01.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:			
//
//
//
/////////////////////////////////////////////////////////////////////////////////////
// Copyright 2000 by x-treme
/////////////////////////////////////////////////////////////////////////////////////

// XGame-includes
#include "XPlay.h"

XConnectionManager	XPlay::m_pConnectionManager;
XSessionManager		XPlay::m_pSessionManager;
XPlayerManager		XPlay::m_pPlayerManager;


/////////////////////////////////////////////////////////////////////////////////
// Klasse XPlayer

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlayer::XPlayer
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Konstruktor
/////////////////////////////////////////////////////////////////////////////////////

XPlayer::XPlayer()
{
	m_lpShortPlayerName	= NULL;
	m_lpLongPlayerName	= NULL;
	m_lpPlayerId		= NULL;
	m_dwPlayerType		= 0;

	m_pNext				= NULL;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlayer::~XPlayer
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Destruktor
/////////////////////////////////////////////////////////////////////////////////////

XPlayer::~XPlayer()
{
	if(m_lpPlayerId)
	{
		// Falls Speicher fr Member in Klasse reserviert wurde - weg damit
		free(m_lpPlayerId);
	}
}

// Ende Klasse XPlayer
/////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////
// Klasse XSession

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XSession::XSession
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Konstruktor
/////////////////////////////////////////////////////////////////////////////////////

XSession::XSession()
{
	m_lpShortName	= NULL;
	m_lpGuid		= NULL;

	m_pNext			= NULL;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XSession::~XSession
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Destruktor
/////////////////////////////////////////////////////////////////////////////////////

XSession::~XSession()
{
	if(m_lpGuid)
	{
		// Falls Speicher fr Member in Klasse reserviert wurde - weg damit
		free(m_lpGuid);
	}
}

// Ende Klasse XSession
/////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////
// Klasse XConnection

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XConnection::XConnection
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Konstruktor
/////////////////////////////////////////////////////////////////////////////////////

XConnection::XConnection()
{
	m_lpConnection	= NULL;
	m_lpShortName	= NULL;

	m_pNext			= NULL;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XConnection::XConnection
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Konstruktor
/////////////////////////////////////////////////////////////////////////////////////

XConnection::~XConnection()
{
	if(m_lpConnection)
	{
		// Falls Speicher fr Member in Klasse reserviert wurde - weg damit
		free(m_lpConnection);
	}
}

// Ende Klasse XConnection
/////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////
// Klasse XPlayerManager

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlayerManager::XPlayerManager
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Konstruktor
/////////////////////////////////////////////////////////////////////////////////////

XPlayerManager::XPlayerManager()
{
	m_nCount	= 0;
	m_pFirst	= NULL;
	m_pCurrent	= NULL;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlayerManager::addPlayer
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Fgt einen Spieler an das Ende der Liste ein
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XPlayerManager::addPlayer(DPID pidID, DWORD m_dwPlayerType, LPCDPNAME lpName)
{
	if(m_pFirst == NULL)
	{
		// Neues Objekt fr Daten
		m_pFirst = new XPlayer;

		// rein mit den Daten 
		m_pFirst->m_lpShortPlayerName	= lpName->lpszShortNameA;
		m_pFirst->m_lpLongPlayerName	= lpName->lpszLongNameA;
		m_pFirst->m_dwPlayerType		= m_dwPlayerType;

		m_pFirst->m_lpPlayerId = (LPDPID) malloc(sizeof(DPID));
		*m_pFirst->m_lpPlayerId = pidID;

		// Das Ende der Liste setzen
		m_pFirst->m_pNext = NULL;

		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XPlayerManager::addPlayer > Name = ");
		XLogging::log(m_pFirst->m_lpShortPlayerName);
		XLogging::log("\n");
		#endif
	}
	else
	{
		XPlayer *pDummy = NULL;
		
		// Dummy einrichten
		pDummy = m_pFirst;

		// letztes Objekt in Liste suchen
		while(pDummy->m_pNext != NULL)
		{
			pDummy = pDummy->m_pNext;
		}

		// Speicher fr letztes Element
		pDummy->m_pNext = new XPlayer;

		// Auf jetzt aktuelles Element
		pDummy = pDummy->m_pNext;

		// rein mit den Daten
		pDummy->m_lpShortPlayerName	= lpName->lpszShortNameA;
		pDummy->m_lpLongPlayerName	= lpName->lpszLongNameA;
		pDummy->m_dwPlayerType		= m_dwPlayerType;

		pDummy->m_lpPlayerId = (LPDPID) malloc(sizeof(DPID));
		*pDummy->m_lpPlayerId = pidID;

		// Ende der Liste setzen
		pDummy->m_pNext = NULL;

		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XPlayerManager::addPlayer > Name = ");
		XLogging::log(pDummy->m_lpShortPlayerName);
		XLogging::log("\n");
		#endif
	}

	m_nCount++;

	#if defined(XDEBUG) || defined(XPLAYDEBUG)
	XLogging::log("XPlayerManager::addPlayer > m_nCount = ");
	XLogging::log(m_nCount);
	XLogging::log("\n");
	#endif

	return DP_OK;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlayerManager::getFirstPlayerName
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Gibt den Namen des ersten Spielers in der Liste zurck
/////////////////////////////////////////////////////////////////////////////////////

LPSTR XPlayerManager::getFirstPlayerName()
{
	if(!m_pFirst)
	{
		return NULL;	
	}

	if(m_pFirst->m_pNext != NULL)
	{
		m_pCurrent = m_pFirst->m_pNext;
	}
	else
	{
		m_pCurrent = NULL;
	}

	return m_pFirst->m_lpShortPlayerName; 
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlayerManager::getNextPlayerName
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Gibt den Namen des jeweiligen Spielers in der Liste zurck
/////////////////////////////////////////////////////////////////////////////////////

LPSTR XPlayerManager::getNextPlayerName()
{
	if(m_pCurrent != NULL)
	{
		XPlayer *pDummy = NULL;

		pDummy = m_pCurrent;

		m_pCurrent = m_pCurrent->m_pNext;

		return pDummy->m_lpShortPlayerName;
	}
	
	// Kein weiteres Element - also kein Name
	return NULL;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlayerManager::getFirstPlayer
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Gibt die ID des ersten Spielers in der Liste zurck
/////////////////////////////////////////////////////////////////////////////////////

LPDPID XPlayerManager::getFirstPlayer()
{
	if(!m_pFirst)
	{
		return NULL;
	}

	if(m_pFirst->m_pNext != NULL)
	{
		m_pCurrent = m_pFirst->m_pNext;
	}
	else
	{
		m_pCurrent = NULL;
	}

	return m_pFirst->m_lpPlayerId; 
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlayerManager::getNextPlayer
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Gibt die ID des jeweiligen Spielers in der Liste zurck
/////////////////////////////////////////////////////////////////////////////////////

LPDPID XPlayerManager::getNextPlayer()
{
	if(m_pCurrent != NULL)
	{
		XPlayer *pDummy = NULL;

		pDummy = m_pCurrent;

		m_pCurrent = m_pCurrent->m_pNext;

		return pDummy->m_lpPlayerId;
	}
	
	// Kein weiteres Element - also 
	return NULL;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlayerManager::getPlayer
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Gibt den Namen des Spielers in der Liste der die 
//					angegebene ID hat zurck
/////////////////////////////////////////////////////////////////////////////////////

LPSTR XPlayerManager::getPlayer(LPDPID playerId)
{
	if(!m_pFirst)
	{
		return NULL;
	}

	XPlayer *pDummy;

	pDummy = m_pFirst;

	do
	{
		if(pDummy->m_lpPlayerId == playerId)
		{
			return pDummy->m_lpShortPlayerName;
		}
		else
		{
			pDummy = pDummy->m_pNext;
		}
	}
	while(pDummy != NULL);
	
	// Ende der Liste erreicht - raus hier
	return NULL;	
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlayerManager::releasePlayers
/////////////////////////////////////////////////////////////////////////////////////
// Info:			lscht ALLE Spieler in der Liste
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XPlayerManager::releasePlayers()
{
	XPlayer *pDummy, 
			*pDummy2 = NULL;

	while(m_nCount > 1)
	{
		pDummy = m_pFirst;
		
		while(pDummy->m_pNext != NULL)
		{
			pDummy = pDummy->m_pNext;
		}

		pDummy2 = pDummy->m_pNext;

		delete pDummy2;
		pDummy2 = NULL;
		m_nCount--;

		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XPlayerManager::releasePlayer > m_nCount = ");
		XLogging::log(m_nCount);
		XLogging::log("\n");
		#endif
	}

	if(m_nCount == 1)
	{
		delete m_pFirst;
		m_pFirst = NULL;
		m_nCount--;

		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XPlayerManager::releasePlayer > m_nCount = ");
		XLogging::log(m_nCount);
		XLogging::log("\n");
		#endif
	}
	
	return DP_OK;
}


// Ende Klasse XPlayerManager
/////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////
// Klasse XSessionManager

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XSessionManager::XSessionManager
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Konstruktor
/////////////////////////////////////////////////////////////////////////////////////

XSessionManager::XSessionManager()
{
	m_nCount		= 0;
	m_pFirst		= NULL;
	m_pCurrent	= NULL;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XSessionManager::addSession
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Fgt eine Session an das Ende der Liste ein
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XSessionManager::addSession(LPDPSESSIONDESC2 lpSessionDesc)
{
	if(m_pFirst == NULL)
	{
		// Neues Objekt fr Daten
		m_pFirst = new XSession;

		// rein mit den Daten 
		m_pFirst->m_lpShortName	= lpSessionDesc->lpszSessionNameA;

		m_pFirst->m_lpGuid = (LPGUID) malloc(sizeof(GUID));
		*m_pFirst->m_lpGuid = lpSessionDesc->guidInstance;

		// Das Ende der Liste setzen
		m_pFirst->m_pNext = NULL;
	}
	else
	{
		XSession *pDummy = NULL;
		
		// Dummy einrichten
		pDummy = m_pFirst;

		// letztes Objekt in Liste suchen
		while(pDummy->m_pNext != NULL)
		{
			pDummy = pDummy->m_pNext;
		}

		// Speicher fr letztes Element
		pDummy->m_pNext = new XSession;

		// Auf jetzt aktuelles Element
		pDummy = pDummy->m_pNext;

		// rein mit den Daten
		pDummy->m_lpShortName	= lpSessionDesc->lpszSessionNameA;
		
		pDummy->m_lpGuid = (LPGUID) malloc(sizeof(GUID));
		*pDummy->m_lpGuid = lpSessionDesc->guidInstance;

		// Ende der Liste setzen
		pDummy->m_pNext = NULL;
	}

	m_nCount++;

	#if defined(XDEBUG) || defined(XPLAYDEBUG)
	XLogging::log("XSessionManager::addSession > m_nCount = ");
	XLogging::log(m_nCount);
	XLogging::log("\n");
	#endif

	return DP_OK;	
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XSessionManager::getFirstSessionName
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Gibt den Namen der ersten Session in der Liste zurck
/////////////////////////////////////////////////////////////////////////////////////

LPSTR XSessionManager::getFirstSessionName()
{
	if(!m_pFirst)
	{
		return NULL;
	}
	if(m_pFirst->m_pNext != NULL)
	{
		m_pCurrent = m_pFirst->m_pNext;
	}
	else
	{
		m_pCurrent = NULL;
	}

	return m_pFirst->m_lpShortName; 
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XSessionManager::getNextSessionName
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Gibt den Namen der jeweiligen nchsten Session in 
//					der Liste zurck
/////////////////////////////////////////////////////////////////////////////////////

LPSTR XSessionManager::getNextSessionName()
{
	if(m_pCurrent != NULL)
	{
		XSession *pDummy = NULL;

		pDummy = m_pCurrent;

		m_pCurrent = m_pCurrent->m_pNext;

		return pDummy->m_lpShortName;
	}
	
	// Kein weiteres Element - also kein Name
	return NULL;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XSessionManager::getFirstSession
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Gibt den Guid der ersten Session in der Liste zurck
/////////////////////////////////////////////////////////////////////////////////////

LPGUID XSessionManager::getFirstSession()
{
	if(!m_pFirst)
	{
		return NULL;
	}

	if(m_pFirst->m_pNext != NULL)
	{
		m_pCurrent = m_pFirst->m_pNext;
	}
	else
	{
		m_pCurrent = NULL;
	}

	return m_pFirst->m_lpGuid; 
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XSessionManager::getNextSession
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Gibt den jeweiligen nchsten Guid der Session in 
//					der Liste zurck
/////////////////////////////////////////////////////////////////////////////////////

LPGUID XSessionManager::getNextSession()
{
	if(m_pCurrent != NULL)
	{
		XSession *pDummy = NULL;

		pDummy = m_pCurrent;

		m_pCurrent = m_pCurrent->m_pNext;

		return pDummy->m_lpGuid;
	}
	
	// Kein weiteres Element - also 
	return NULL;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XSessionManager::getSession
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Gibt den Guid der Session in der Liste der den 
//					angegebenen Namen hat zurck
/////////////////////////////////////////////////////////////////////////////////////

LPSTR XSessionManager::getSession(LPGUID lpSession)
{
	if(m_pFirst == NULL)
	{
		return NULL;
	}

	XSession *pDummy;

	pDummy = m_pFirst;

	do
	{
		if(pDummy->m_lpGuid == lpSession)
		{
			return pDummy->m_lpShortName;
		}
		else
		{
			pDummy = pDummy->m_pNext;
		}
	}
	while(pDummy != NULL);

	// Ende der Liste erreicht - raus hier
	return NULL;
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XSessionManager::releaseSessions
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Lscht ALLE Sessions in der Liste
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XSessionManager::releaseSessions()
{
	XSession	*pDummy, 
				*pDummy2 = NULL;

	while(m_nCount > 1)
	{
		pDummy = m_pFirst;
		
		while(pDummy->m_pNext != NULL)
		{
			pDummy = pDummy->m_pNext;
		}

		pDummy2 = pDummy->m_pNext;

		delete pDummy2;
		pDummy2 = NULL;
		m_nCount--;

		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XSessionManager::releaseSessions > m_nCount = ");
		XLogging::log(m_nCount);
		XLogging::log("\n");
		#endif
	}

	if(m_nCount == 1)
	{
		delete m_pFirst;
		m_pFirst = NULL;
		m_nCount--;

		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XSessionManager::releaseSessions > m_nCount = ");
		XLogging::log(m_nCount);
		XLogging::log("\n");
		#endif
	}
	
	return DP_OK;
}

// Ende Klasse XSessionManager
/////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////
// Klasse XConnectionManager

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XConnectionManager::XConnectionManager
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Konstruktor
/////////////////////////////////////////////////////////////////////////////////////

XConnectionManager::XConnectionManager()
{
	m_nCount		= 0;
	m_pFirst		= NULL;
	m_pCurrent	= NULL;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XConnectionManager::addConnection
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Fgt eine Connection an das Ende der Liste ein
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XConnectionManager::addConnection(LPCGUID lpMyGuidSP, 
									   LPVOID lpMyConnection, 
									   DWORD dwMyConnectionSize, 
									   LPCDPNAME lpMyName, 
									   DWORD dwMyFlags, 
									   LPVOID lpMyContext)
{
	if(m_pFirst == NULL)
	{
		// Neues Objekt fr Daten
		m_pFirst = new XConnection;

		// rein mit den Daten 
		m_pFirst->m_lpShortName	= lpMyName->lpszShortNameA;
		m_pFirst->m_lpConnection = malloc(dwMyConnectionSize);
		memcpy(m_pFirst->m_lpConnection, lpMyConnection, dwMyConnectionSize);

		// Das Ende der Liste setzen
		m_pFirst->m_pNext = NULL;
	}
	else
	{
		XConnection *pDummy = NULL;
		
		// Dummy einrichten
		pDummy = m_pFirst;

		// letztes Objekt in Liste suchen
		while(pDummy->m_pNext != NULL)
		{
			pDummy = pDummy->m_pNext;
		}

		// Speicher fr letztes Element
		pDummy->m_pNext = new XConnection;

		// Auf jetzt aktuelles Element
		pDummy = pDummy->m_pNext;

		// rein mit den Daten
		pDummy->m_lpShortName	= lpMyName->lpszShortNameA;
		pDummy->m_lpConnection = malloc(dwMyConnectionSize);
		memcpy(pDummy->m_lpConnection, lpMyConnection, dwMyConnectionSize);

		// Ende der Liste setzen
		pDummy->m_pNext = NULL;
	}

	m_nCount++;

	#if defined(XDEBUG) || defined(XPLAYDEBUG)
	XLogging::log("XConnectionManager::addConnection > m_nCount = ");
	XLogging::log(m_nCount);
	XLogging::log("\n");
	#endif

	return DP_OK;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XConnectionManager::getFirstConnectionName
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Gibt den Namen der ersten Connection in der Liste zurck
/////////////////////////////////////////////////////////////////////////////////////

LPSTR XConnectionManager::getFirstConnectionName()
{
	if(!m_pFirst)
	{
		return NULL;
	}
	
	if(m_pFirst->m_pNext != NULL)
	{
		m_pCurrent = m_pFirst->m_pNext;
	}
	else
	{
		m_pCurrent = NULL;
	}

	return m_pFirst->m_lpShortName; 
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XConnectionManager::getNextConnectionName
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Gibt den Namen der jeweils nchsten Connection in 
//					der Liste zurck
/////////////////////////////////////////////////////////////////////////////////////

LPSTR XConnectionManager::getNextConnectionName()
{
	if(m_pCurrent != NULL)
	{
		XConnection *pDummy = NULL;

		pDummy = m_pCurrent;

		m_pCurrent = m_pCurrent->m_pNext;

		return pDummy->m_lpShortName;
	}
	
	// Kein weiteres Element - also kein Name
	return NULL;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XConnectionManager::getFirstConnection
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Gibt den Typ der ersten Connection in der Liste zurck
/////////////////////////////////////////////////////////////////////////////////////

LPVOID XConnectionManager::getFirstConnection()
{
	if(!m_pFirst)
	{
		return NULL;
	}
	
	if(m_pFirst->m_pNext != NULL)
	{
		m_pCurrent = m_pFirst->m_pNext;
	}
	else
	{
		m_pCurrent = NULL;
	}

	return m_pFirst->m_lpConnection; 
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XConnectionManager::getNextConnection
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Gibt den Typ der jeweils nchsten Connection 
//					in der Liste zurck
/////////////////////////////////////////////////////////////////////////////////////

LPVOID XConnectionManager::getNextConnection()
{
	if(m_pCurrent != NULL)
	{
		XConnection *pDummy = NULL;

		pDummy = m_pCurrent;

		m_pCurrent = m_pCurrent->m_pNext;

		return pDummy->m_lpConnection;
	}
	
	// Kein weiteres Element - also 
	return NULL;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XConnectionManager::getConnection
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Gibt den Typ der Connection in der Liste der den 
//					angegebenen Namen hat zurck
/////////////////////////////////////////////////////////////////////////////////////

LPVOID XConnectionManager::getConnection(LPSTR connectionName)
{
	if(!m_pFirst)
	{
		return NULL;
	}

	XConnection *pDummy = NULL;

	pDummy = m_pFirst;

	do
	{
		if(pDummy->m_lpShortName == connectionName)
		{
			return pDummy->m_lpConnection;
		}
		else
		{
			pDummy = pDummy->m_pNext;
		}
	}
	while(pDummy != NULL);

	// Ende der Liste erreicht - raus hier
	return NULL;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XConnectionManager::releaseConnections
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Lscht ALLE Connections in der Liste
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XConnectionManager::releaseConnections()
{
	XConnection *pDummy, 
				*pDummy2 = NULL;

	while(m_nCount > 1)
	{
		pDummy = m_pFirst;
		
		while(pDummy->m_pNext != NULL)
		{
			pDummy = pDummy->m_pNext;
		}

		pDummy2 = pDummy->m_pNext;

		delete pDummy2;
		pDummy2 = NULL;
		m_nCount--;

		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XConnectionManager::releaseConnection > m_nCount = ");
		XLogging::log(m_nCount);
		XLogging::log("\n");
		#endif
	}

	if(m_nCount == 1)
	{
		delete m_pFirst;
		m_pFirst = NULL;
		m_nCount--;

		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XConnectionManager::releaseConnection > m_nCount = ");
		XLogging::log(m_nCount);
		XLogging::log("\n");
		#endif
	}
	
	return DP_OK;
}

// Ende Klasse XConnectionManager
/////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////
// Klasse XPlay

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::XPlay
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Konstruktor
/////////////////////////////////////////////////////////////////////////////////////

XPlay::XPlay()
{
	m_lpDirectPlay		= NULL;

	m_lpMessageBuffer	= NULL;
	m_dwBufferSize		= 0;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::~XPlay
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Destruktor
/////////////////////////////////////////////////////////////////////////////////////

XPlay::~XPlay()
{
	uninitialize();
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::initialize
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Initialisiert Direct-Play-Objekt
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XPlay::initialize()
{
	HRESULT hResult;

	// besteht Direct-Input Objekt schon?
	if (m_lpDirectPlay)
	{
		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XInput::initialize > (WARNUNG!!!) DirectPlay-Objekt existiert bereits\n");
		#endif		
	
		return DPERR_INVALIDPARAM;
	}

	// Vorbereitung fr das Anlegen des DirectPlay Objektes
	hResult = CoInitialize(NULL);

    if(hResult != S_OK)
	{
		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XPlay::initialize > (FEHLER!!!) Konnte COM nicht initialisieren\n");
		#endif
		
		return hResult;
	}

	// DirectPlay Objekt anlegen
	hResult = CoCreateInstance(CLSID_DirectPlay, NULL, CLSCTX_ALL, IID_IDirectPlay4A, (VOID**)&m_lpDirectPlay);

    if(hResult != S_OK)
	{
		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XPlay::initialize > (FEHLER!!!) Konnte DirectInput7-Objekt nicht erzeugen\n");
		#endif
		
		m_lpDirectPlay = NULL;
		return hResult;
	}

	#if defined(XDEBUG) || defined(XPLAYDEBUG)
	XLogging::log("XPlay::initialize > DirectPlay-Objekt erzeugt\n");
	#endif

	return hResult;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::enumConnections
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Zhlt verfgbare Connection-Typen auf dem jeweilgen Rechner ab
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XPlay::enumConnections()
{
	HRESULT hResult;

	// Dummy
	LPVOID lpVoid = NULL;

	// Callback Funktion zhlt jetzt ber diesen Aufruf Connections ab  
	hResult = m_lpDirectPlay->EnumConnections(NULL, (LPDPENUMCONNECTIONSCALLBACK) enumConnectionCallback, lpVoid, 0);
	
	if(hResult != DP_OK)
	{
		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XPlay::enumConnections > (FEHLER!!!) Konnte Connections nicht abzaehlen\n");
		#endif
		
		return hResult;
	}

	return hResult;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::enumConnectionCallback
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Callback-Methode die von enumConnections aufgerufen wird
/////////////////////////////////////////////////////////////////////////////////////

BOOL WINAPI XPlay::enumConnectionCallback(LPCGUID lpguidSP, 
											LPVOID m_lpConnection, 
											DWORD dwConnectionSize, 
											LPCDPNAME lpName, 
											DWORD dwFlags, 
											LPVOID lpContext)
{
	HRESULT			hResult;
    LPDIRECTPLAY4	lpDP = NULL;
 
    // Test ob Connection kompatibel
	hResult = CoCreateInstance(CLSID_DirectPlay, NULL, CLSCTX_ALL, IID_IDirectPlay4A, (VOID**)&lpDP);

	if(hResult != S_OK)
	{
		return false;
	}
 
    // Test ob Connection kompatibel
    hResult = lpDP->InitializeConnection(m_lpConnection, 0);
    
	if(hResult != DP_OK)
	{
        lpDP->Release();
        return false;		
    }
 
    // Test erfolgreich - weg mit dem Objekt
	lpDP->Release();
	
	// Jetzt Daten behandeln
	hResult = XPlay::m_pConnectionManager.addConnection(lpguidSP, 
														m_lpConnection, 
														dwConnectionSize, 
														lpName, 
														dwFlags, 
														lpContext);
	if(hResult != DP_OK)
	{
		return false;
	}
	
	return true;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::getFirstConnectionName
/////////////////////////////////////////////////////////////////////////////////////
// Info:			siehe XConnectionManager::getFirstConnectionName
/////////////////////////////////////////////////////////////////////////////////////

LPSTR XPlay::getFirstConnectionName()
{
	return m_pConnectionManager.getFirstConnectionName();
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::getNextConnectionName
/////////////////////////////////////////////////////////////////////////////////////
// Info:			siehe XConnectionManager::getNextConnectionName
/////////////////////////////////////////////////////////////////////////////////////

LPSTR XPlay::getNextConnectionName()
{
	return m_pConnectionManager.getNextConnectionName();
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::getFirstConnection
/////////////////////////////////////////////////////////////////////////////////////
// Info:			siehe XConnectionManager::getFirstConnection
/////////////////////////////////////////////////////////////////////////////////////

LPVOID XPlay::getFirstConnection()
{
	return m_pConnectionManager.getFirstConnection();
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::getNextConnection
/////////////////////////////////////////////////////////////////////////////////////
// Info:			siehe XConnectionManager::getNextConnection
/////////////////////////////////////////////////////////////////////////////////////

LPVOID XPlay::getNextConnection()
{
	return m_pConnectionManager.getNextConnection();
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::getConnection
/////////////////////////////////////////////////////////////////////////////////////
// Info:			siehe XConnectionManager::getConnection
/////////////////////////////////////////////////////////////////////////////////////

LPVOID XPlay::getConnection(LPSTR connectionName)
{
	return m_pConnectionManager.getConnection(connectionName);
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::initializeConnection
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Initialisiert die jeweilige Verbindung
//					Verbindungs-Typ ist ber Zugriffs-Methoden der Liste verfgbar
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XPlay::initializeConnection(LPVOID pOurConnection)
{
	HRESULT hResult;

	// Initialisieren der Connection
	hResult = m_lpDirectPlay->InitializeConnection(pOurConnection, 0);

	if(hResult != DP_OK)
	{
		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XPlay::createConnection > (FEHLER!!!) Konnte Connection nicht anlegen\n");
		#endif
		
		return hResult;
	}

	return hResult;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::releaseConnections
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Lscht sie Connection-Liste
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XPlay::releaseConnections()
{
	return m_pConnectionManager.releaseConnections();
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::enumSessions
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Zhlt verfgbare Sessions im Netzwerk ab
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XPlay::enumSessions(GUID g_Guid)
{
	// Dummy
	LPVOID			lpVoid = NULL;
	HRESULT			hResult;
	DPSESSIONDESC2	dpSessionDesc;
	
	// Vorbereiten der Daten zwecks abzhlen der Sessions
	ZeroMemory(&dpSessionDesc, sizeof(dpSessionDesc));
	dpSessionDesc.dwSize = sizeof(dpSessionDesc);
	dpSessionDesc.guidApplication = g_Guid;

	// Callback Funktion zhlt jetzt ber Aufruf Sessions ab
	hResult = m_lpDirectPlay->EnumSessions(&dpSessionDesc, 0, (LPDPENUMSESSIONSCALLBACK2) enumSessionCallback, lpVoid, DPENUMSESSIONS_ALL);		

	if(hResult != DP_OK)
	{
		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XPlay::enumSessions > (FEHLER!!!) Konnte Sessions nicht abzaehlen\n");
		#endif
		
		return hResult;
	}

	return hResult;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::enumSessionCallback
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Callback-Methode die von enumSessions aufgerufen wird
/////////////////////////////////////////////////////////////////////////////////////

BOOL WINAPI XPlay::enumSessionCallback(LPDPSESSIONDESC2 lpSessionDesc, 
									   LPDWORD lpdwTimeOut, 
									   DWORD dwFlags, 
									   LPVOID lpContext)
{
	HRESULT hResult;

	// Test ob Zeitlimit berschirtten
	if(dwFlags & DPESC_TIMEDOUT)
	{
		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XPlay::enumSessionCallback > (ACHTUNG!!!) Callback liefert Timeout\n");
		#endif
		
		return false;
	}

	// Jetzt die Daten verpacken
	hResult = XPlay::m_pSessionManager.addSession(lpSessionDesc);

	if(hResult != DP_OK)
	{
		return false;
	}

	return true;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::getFirstSessionName
/////////////////////////////////////////////////////////////////////////////////////
// Info:			siehe XSessionManager::getFirstSessionName
/////////////////////////////////////////////////////////////////////////////////////

LPSTR XPlay::getFirstSessionName()
{
	return m_pSessionManager.getFirstSessionName();
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::getNextSessionName
/////////////////////////////////////////////////////////////////////////////////////
// Info:			siehe XSessionManager::getnextSessionName
/////////////////////////////////////////////////////////////////////////////////////

LPSTR XPlay::getNextSessionName()
{
	return m_pSessionManager.getNextSessionName();
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::getFirstSession
/////////////////////////////////////////////////////////////////////////////////////
// Info:			siehe XSessionManager::getFirstSession
/////////////////////////////////////////////////////////////////////////////////////

LPGUID XPlay::getFirstSession()
{
	return m_pSessionManager.getFirstSession();
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::getNextSession
/////////////////////////////////////////////////////////////////////////////////////
// Info:			siehe XSessionManager::getNextSession
/////////////////////////////////////////////////////////////////////////////////////

LPGUID XPlay::getNextSession()
{
	return m_pSessionManager.getNextSession();
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::getSession
/////////////////////////////////////////////////////////////////////////////////////
// Info:			siehe XSessionManager::getSession
/////////////////////////////////////////////////////////////////////////////////////

LPSTR XPlay::getSession(LPGUID lpSession)
{
	return m_pSessionManager.getSession(lpSession);
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::createSession
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Erstellt eine Session 
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XPlay::createSession(LPSTR sessionName, GUID g_Guid)
{
	HRESULT hResult;

	DPSESSIONDESC2 dpSessionDesc;
	
	// Daten fr Session vorbereiten
	ZeroMemory(&dpSessionDesc, sizeof(dpSessionDesc));
	dpSessionDesc.dwSize			= sizeof(dpSessionDesc);
	dpSessionDesc.dwFlags			= 0;
	dpSessionDesc.guidApplication	= g_Guid;
	dpSessionDesc.lpszSessionNameA	= sessionName;
	
	// Session erzeugen
	hResult = m_lpDirectPlay->Open(&dpSessionDesc, DPOPEN_CREATE);

	if(hResult != DP_OK)
	{
		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XPlay::createSession > (FEHLER!!!) Konnte Session nicht erstellen\n");
		#endif
		
		return hResult;
	}

	return hResult;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::joinSession
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Stellt eine Verbindung zu einer Session her
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XPlay::joinSession(LPGUID sessionGuid, GUID g_Guid)
{
	HRESULT			hResult;
	DPSESSIONDESC2	dpSessionDesc;
	
	// Daten fr Session vorbereiten
	ZeroMemory(&dpSessionDesc, sizeof(dpSessionDesc));
	dpSessionDesc.dwSize			= sizeof(dpSessionDesc);
	dpSessionDesc.guidInstance		= *sessionGuid;
	dpSessionDesc.guidApplication	= g_Guid;
	
	// Mit der Session verbinden
	hResult = m_lpDirectPlay->Open(&dpSessionDesc, DPOPEN_JOIN);

	if(hResult != DP_OK)
	{
		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XPlay::joinSession > (FEHLER!!!) Konnte nicht an der Session teilnehmen\n");
		#endif
		
		return hResult;
	}

	return hResult;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::releaseSessions
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Lscht sie Session-Liste
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XPlay::releaseSessions()
{
	return m_pSessionManager.releaseSessions();
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::enumPlayer
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Zhlt verfgbare Players in der jeweiligen Session ab
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XPlay::enumPlayers(LPGUID lpSessionGuid, DWORD m_dwPlayerType)
{
	// Dummy
	LPVOID	lpVoid = NULL;

	HRESULT	hResult;
	
	// Callback Funktion zhlt jetzt ber Aufruf Players ab
	hResult = m_lpDirectPlay->EnumPlayers(lpSessionGuid, (LPDPENUMPLAYERSCALLBACK2) enumPlayerCallback, lpVoid, m_dwPlayerType);		

	if(hResult != DP_OK)
	{
		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XPlay::enumPlayers > (FEHLER!!!) Konnte Player nicht abzaehlen\n");
		#endif
		
		return hResult;
	}

	return hResult;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::enumPlayerCallback
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Callback-Methode die von enumPlayers aufgerufen wird
/////////////////////////////////////////////////////////////////////////////////////

BOOL WINAPI XPlay::enumPlayerCallback(DPID pidID, 
									  DWORD m_dwPlayerType, 
									  LPCDPNAME lpName, 
									  DWORD dwFlags, 
									  LPVOID lpContext)
{
	HRESULT hResult;

	// Daten verpacken
	hResult =  XPlay::m_pPlayerManager.addPlayer(pidID, m_dwPlayerType, lpName);

	if(hResult != DP_OK)
	{
		return false;
	}

	return true;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::getFirstPlayerName
/////////////////////////////////////////////////////////////////////////////////////
// Info:			siehe XPlayerManager::getFirstPlayerName
/////////////////////////////////////////////////////////////////////////////////////

LPSTR XPlay::getFirstPlayerName()
{
	return m_pPlayerManager.getFirstPlayerName();
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::getNextPlayerName
/////////////////////////////////////////////////////////////////////////////////////
// Info:			siehe XPlayerManager::getNextPlayerName
/////////////////////////////////////////////////////////////////////////////////////

LPSTR XPlay::getNextPlayerName()
{
	return m_pPlayerManager.getNextPlayerName();
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::getFirstPlayer
/////////////////////////////////////////////////////////////////////////////////////
// Info:			siehe XPlayerManager::getFirstPlayer
/////////////////////////////////////////////////////////////////////////////////////

LPDPID XPlay::getFirstPlayer()
{
	return m_pPlayerManager.getFirstPlayer();
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::getNextPlayer
/////////////////////////////////////////////////////////////////////////////////////
// Info:			siehe XPlayerManager::getNextPlayer
/////////////////////////////////////////////////////////////////////////////////////

LPDPID XPlay::getNextPlayer()
{
	return m_pPlayerManager.getNextPlayer();
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::getPlayer
/////////////////////////////////////////////////////////////////////////////////////
// Info:			siehe XPlayerManager::getPlayer
/////////////////////////////////////////////////////////////////////////////////////

LPSTR XPlay::getPlayer(LPDPID playerId)
{
	return m_pPlayerManager.getPlayer(playerId);
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::createPlayer
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Erstellt einen Spieler
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XPlay::createPlayer(HANDLE hPlayerEvent, LPSTR playerName, DWORD m_dwPlayerType)
{
	HRESULT	hResult;
	DPNAME	dpPlayerName;
	DPID	m_lpPlayerId;
	
	// Daten fr Player vorbereiten
	ZeroMemory(&dpPlayerName, sizeof(dpPlayerName));
	dpPlayerName.dwSize = sizeof(dpPlayerName);
	dpPlayerName.lpszShortNameA = playerName;
	
	// Player anlegen
	hResult = m_lpDirectPlay->CreatePlayer(&m_lpPlayerId, &dpPlayerName, hPlayerEvent, NULL, 0, m_dwPlayerType);

	if(hResult != DP_OK)
	{
		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XPlay::createPlayer > (FEHLER!!!) Konnte Player nicht erstellen\n");
		#endif
		
		return hResult;
	}

	return hResult;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::releasePlayers
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Lscht sie Spieler-Liste
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XPlay::releasePlayers()
{
	return m_pPlayerManager.releasePlayers();
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::sendMessage
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Sendet eine Nachricht
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XPlay::sendMessage(LPVOID lpData, DWORD dwDataSize, DPID dpFromId, DPID dpToId, DWORD dwFlags)
{
	HRESULT hResult;

	hResult = m_lpDirectPlay->Send(dpFromId, dpToId, dwFlags, lpData, dwDataSize);

	if(hResult != DP_OK)
	{
		switch(hResult)
		{
			case DPERR_BUSY:
				#if defined(XDEBUG) || defined(XPLAYDEBUG)
				XLogging::log("XPlay::sendMessage > (ACHTUNG!!!) Medium zu beschaeftigt\n");
				#endif

				break;
			
			case DPERR_INVALIDPARAMS:
				#if defined(XDEBUG) || defined(XPLAYDEBUG)
				XLogging::log("XPlay::sendMessage > (ACHTUNG!!!) Falsche Parameter\n");
				#endif

				break;

			case DPERR_INVALIDPLAYER:
				#if defined(XDEBUG) || defined(XPLAYDEBUG)
				XLogging::log("XPlay::sendMessage > (ACHTUNG!!!) Falscher Spieler\n");
				#endif

				break;

			case DPERR_NOTLOGGEDIN:
				#if defined(XDEBUG) || defined(XPLAYDEBUG)
				XLogging::log("XPlay::sendMessage > (ACHTUNG!!!) Keine Verbindung zum Server\n");
				#endif

				break;

			case DPERR_SENDTOOBIG:
				#if defined(XDEBUG) || defined(XPLAYDEBUG)
				XLogging::log("XPlay::sendMessage > (ACHTUNG!!!) Nachricht zu gross\n");
				#endif

				break;

			default:
				#if defined(XDEBUG) || defined(XPLAYDEBUG)
				XLogging::log("XPlay::sendMessage > (FEHLER!!!) Konnte Nachricht nicht senden\n");
				#endif

				break;
		}

		return hResult;
	}

	#if defined(XDEBUG) || defined(XPLAYDEBUG)
	XLogging::log("XPlay::sendMessage > Nachricht erfolgreich gesendet\n");
	#endif

	return hResult;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::receiveMessage
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Empfngt eine Nachricht
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XPlay::receiveMessage(DPID lpFromId, DPID lpToId, DWORD dwFlags)
{
	HRESULT	hResult;

	hResult = m_lpDirectPlay->Receive(&lpFromId, &lpToId, dwFlags, m_lpMessageBuffer, &m_dwBufferSize);

	if(hResult != DP_OK)
	{
		if(hResult == DPERR_BUFFERTOOSMALL)
		{
			// Noch kein Puffer vorhanden
			if(m_lpMessageBuffer = NULL)
			{
				m_lpMessageBuffer = GlobalAlloc(GHND, m_dwBufferSize);
				
				if(m_lpMessageBuffer == NULL)
				{
					#if defined(XDEBUG) || defined(XPLAYDEBUG)
					XLogging::log("XPlay::receiveMessage > (FEHLER!!!) Kein Puffer verfgbar\n");
					#endif

					return hResult;				
				}
			}
			
			// Puffer vorhanden, aber zu klein
			else
			{
				GlobalFree(m_lpMessageBuffer);

				if(m_lpMessageBuffer != NULL)
				{
					#if defined(XDEBUG) || defined(XPLAYDEBUG)
					XLogging::log("XPlay::receiveMessage > (FEHLER!!!) Konnte Puffer nicht leeren\n");
					#endif

					return hResult;				
				}

				m_lpMessageBuffer = GlobalAlloc(GHND, m_dwBufferSize);
				
				if(m_lpMessageBuffer == NULL)
				{
					#if defined(XDEBUG) || defined(XPLAYDEBUG)
					XLogging::log("XPlay::receiveMessage > (FEHLER!!!) Kein Puffer verfgbar\n");
					#endif

					return hResult;				
				}
			}
			
			// Nochmal Nachricht holen
			
			
			hResult = m_lpDirectPlay->Receive(&lpFromId, &lpToId, dwFlags, m_lpMessageBuffer, &m_dwBufferSize);

			if(hResult != DP_OK)
			{
				#if defined(XDEBUG) || defined(XPLAYDEBUG)
				XLogging::log("XPlay::receiveMessage > (FEHLER!!!) Konnte Nachricht nicht empfangen\n");
				#endif

				return hResult;				
			}
		}
		else
		{
			#if defined(XDEBUG) || defined(XPLAYDEBUG)
			XLogging::log("XPlay::receiveMessage > (FEHLER!!!) Konnte Nachricht nicht empfangen\n");
			#endif

			return hResult;				
		}
	}

	return hResult;
}


/////////////////////////////////////////////////////////////////////////////////////
// Methode:			XPlay::uninitialize
/////////////////////////////////////////////////////////////////////////////////////
// Info:			De-Initialisiert Direct-Play-Objekt
/////////////////////////////////////////////////////////////////////////////////////

HRESULT XPlay::uninitialize()
{
	ULONG	uLong;

	if(m_lpDirectPlay)
	{
		// Lscht komplette Connection - Liste
		m_pConnectionManager.releaseConnections();
		
		// Lscht komplette Session - Liste		
		m_pSessionManager.releaseSessions();
		
		// Lscht komplette Player - Liste
		m_pPlayerManager.releasePlayers();
		
		// Lsen des Direct-Play Objektes
		uLong = m_lpDirectPlay->Release();

		#if defined(XDEBUG) || defined(XPLAYDEBUG)
		XLogging::log("XPlay::uninitialize > DirectPlay-Objekt-Release = ");
		XLogging::log(uLong);
		XLogging::log("\n");
		#endif	

		m_lpDirectPlay = NULL;
	}

	return DP_OK;
}


// Ende Klasse XPlay
/////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	XPlay.cpp
/////////////////////////////////////////////////////////////////////////////////////