/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		XSprite.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			pHreak
//
// Erstelldatum:	04.09.2000
// letzte Aenderung:15.03.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:			XSprite verwaltet ein Bitmap-Sprite, ermoeglicht dessen
//					Darstellung in einer XSurface.
/////////////////////////////////////////////////////////////////////////////////////
// Copyright 2000/2001 by x-treme
/////////////////////////////////////////////////////////////////////////////////////

#define DIRECTDRAW_VERSION 0x0700 // Dann klappts auch mit dem "DirectX>7-SDK"-Nachbarn

#define WIN32_LEAN_AND_MEAN		// Selten genutzte Teile aus Win-Header ausschliessen

#ifndef _XSPRITE_H
#define _XSPRITE_H

// includes
#include <windows.h>

// XGame-includes
#include "XSurface.h"
#include "XDisplay.h"

// Klassen-Deklaration

class	XSprite
{
public:
	XSprite(void);
	virtual ~XSprite(void);

	virtual HRESULT initialize(XDisplay*	pXDisplay,
					   LPSTR		lpstrSpritefile);

	virtual HRESULT initialize(XSprite*		pXSprite);

	virtual HRESULT uninitialize(void);

	virtual bool animate(void);
	
	virtual HRESULT restore(void);

	long getFrameHeight(void);
	long getFrameWidth(void);

	HRESULT	blit(XSurface*	lpDestinationXSurface,
				 DWORD		dwFlags = DDBLT_KEYSRC | DDBLT_WAIT);

	long		m_lFrame;
	long		m_lX,
				m_lY,
				m_lZ;
	bool		m_bVisible;

	// friends deklarieren
	#if defined(XDEBUG) || defined(XSPRITEMANAGERDEBUG)
	friend class XSpriteManager;
	#endif

protected:
	// Nachfolgende Datenmember und Methoden sind "nur" protected,
	// damit erbenden Klassen Zugriff auf sie haben.
	virtual void resetData(void);

	XSurface*	m_pXSurfaceSprite;
	bool		m_bIsInitialized;
	long		m_lNrOfFrames;
	long		m_lFrameWidth;
	long		m_lFrameHeight;
	long		m_lFramesPerRow;

private:
	LPSTR		m_lpstrFilename;
};

#endif//_XSPRITE_H

class	XSprite;

/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	XSprite.h
/////////////////////////////////////////////////////////////////////////////////////