/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		XSpriteManager.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			pHreak
//
// Erstelldatum:	19.09.2000
// letzte nderung:	20.02.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:			
//
//
//
/////////////////////////////////////////////////////////////////////////////////////
// Copyright 2000/2001 by x-treme
/////////////////////////////////////////////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN		// Selten genutzte Teile aus Win-Header ausschliessen

#ifndef _XSPRITEMANAGER_H
#define _XSPRITEMANAGER_H

// includes
#include <windows.h>

// XGame-includes
#include "XSprite.h"

// Klassen-Deklaration

class	XSpriteManagerListItem
{
private:
	XSpriteManagerListItem*	pNext;
	XSpriteManagerListItem*	pPrevious;
	XSprite*				pXSprite;
	bool					bProcessed;

	XSpriteManagerListItem(void);
	XSpriteManagerListItem(XSprite*	pXSpriteToInsert);
protected:

public:

	// friends deklarieren
	friend class XSpriteManager;
};

class	XSpriteManager
{
private:
	XSpriteManagerListItem*	pFirst;
protected:

public:
	XSpriteManager(void);
	virtual ~XSpriteManager(void);

	XSprite* insertSprite(XSprite*	pXSprite);

	XSprite* removeSprite(XSprite*	pXSprite);

	long removeAll(void);

	void animateAll(void);

	HRESULT blitAll(XSurface*	lpDestinationXSurface,
					DWORD		dwFlags = DDBLT_KEYSRC | DDBLT_WAIT);
};

#endif//_XSPRITEMANAGER_H

class	XSpriteManager;

/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	XSpriteManager.h
/////////////////////////////////////////////////////////////////////////////////////